# -*- coding: utf-8 -*-
"""
Created on Fri Oct  1 10:52:03 2021

@author: gregory.viateau
"""

class Pile:
    def __init__(self, valeur=None, suivant=None):         
        self.valeur = valeur        
        self.suivant = suivant
        
    def empiler(self, valeur):        
        self.suivant = Pile(self.valeur, self.suivant)        
        self.valeur = valeur
        
    def depiler(self):
        valeur = self.valeur        
        self.valeur = self.suivant.valeur          
        self.suivant  = self.suivant.suivant
        return valeur    
    
    def est_vide(self):
        return self.suivant is None
    
    def min(self):
        pile_temp = Pile()
        mini = self.depiler()
        pile_temp.empiler(mini)
        while not self.est_vide():
            sommet = self.depiler()
            pile_temp.empiler(sommet)
            if sommet < mini:
                mini = sommet
        while not pile_temp.est_vide():
            self.empiler(pile_temp.depiler())
        return mini
        
    def max(self):
        pile_temp = Pile()
        maxi = self.depiler()
        pile_temp.empiler(maxi)
        while not self.est_vide():
            sommet = self.depiler()
            pile_temp.empiler(sommet)
            if sommet > maxi:
                maxi = sommet
        while not pile_temp.est_vide():
            self.empiler(pile_temp.depiler())
        return maxi


def pile_vide():
    return Pile()

def depiler(pile):
    return pile.depiler()
    
def empiler(pile, element):
    pile.empiler(element)
    
def est_vide(pile):
    return pile.est_vide()


if __name__ == '__main__':
    p = pile_vide()
    p.empiler(4)
    p.empiler(2)
    p.empiler(8)
    p.empiler(5)
    
