# -*- coding: utf-8 -*-
"""
Created on Fri Sep 24 10:41:53 2021

@author: gregory.viateau
"""

from listes import *

def inverser(lst):
    nlst = liste_vide()
    while not est_vide(lst):
        nlst = ajoute(nlst, valeur(lst))
        lst = suite(lst)
    return nlst

def copier(lst):
    return inverser(inverser(lst))

def copier(lst):
    if est_vide(lst):
        return liste_vide()
    return ajoute(copier(suite(lst)), valeur(lst))

def concatener(lst1, lst2):
    "version itérative"
    lst1 = inverser(lst1)
    while not est_vide(lst1):
        lst2 = ajoute(lst2, valeur(lst1))
        lst1 = suite(lst1)
    return lst2
                    
def concatener(lst1, lst2):
    "version récursive"
    if est_vide(lst1):
        return lst2
    return ajoute(concatener(suite(lst1), lst2), valeur(lst1))    

def cherche(e, lst)->bool:
    while not est_vide(lst):
        if valeur(lst) == e:
            return True
        lst = suite(lst)
    return False

def suppr(lst1, lst2):
    "version récursive"
    if est_vide(lst1):
        return liste_vide()
    if cherche(valeur(lst1), lst2):
        return suppr(suite(lst1), lst2)
    else:
        return ajoute(suppr(suite(lst1), lst2), valeur(lst1))

def suppr(lst1, lst2):
    "version itérative"
    lst1 = inverser(lst1)
    nlst = liste_vide()
    while not est_vide(lst1):
        if not cherche(valeur(lst1), lst2):
            nlst = ajoute(nlst, valeur(lst1))
        lst1 = suite(lst1)
    return nlst

def minimum(lst):
    "version itérative"
    mini = valeur(lst) 
    while not est_vide(lst):
        if valeur(lst) < mini:
            mini = valeur(lst)
        lst = suite(lst)
    return mini   

def minimum(lst):
    "version récursive"
    if est_vide(suite(lst)):
        return valeur(lst)
    else:
        return min(valeur(lst), minimum(suite(lst)))

def maximum(lst):
    maxi = valeur(lst) 
    while not est_vide(lst):
        if valeur(lst) > maxi:
            maxi = valeur(lst)
        lst = suite(lst)
    return maxi   

def tri_distinct(lst):
    """
    tri une liste d'éléments distincts,
    utilise la fonction suppr
    """
    lst_triee = liste_vide()
    while not est_vide(lst):
        mini = minimum(lst)
        lst_triee = ajoute(lst_triee, mini)
        lst_a_supprimer = ajoute(liste_vide(), mini)
        lst = suppr(lst, lst_a_supprimer)
    return lst_triee

def copie_suppr(lst, val):
    "renvoie une copie inversée de la liste lst en supprimant la valeur donnée"
    nlst = liste_vide()
    valeur_a_supprimer = True
    while not est_vide(lst):
        tete = valeur(lst)
        if tete==val and valeur_a_supprimer:
            valeur_a_supprimer = False
        else:
            nlst = ajoute(nlst, tete)
        lst = suite(lst)
    return nlst

def tri(lst):
    lst_triee = liste_vide()
    while not est_vide(lst):
        mini = minimum(lst)
        lst_triee = ajoute(lst_triee, mini)
        lst = copie_suppr(lst, mini)
    return lst_triee

if __name__ == '__main__':
    lst1 = liste_vide()
    lst1 = ajoute(lst1, 1)
    lst1 = ajoute(lst1, 2)
    lst1 = ajoute(lst1, 3)
    lst2 = liste_vide()
    lst2 = ajoute(lst2, 4)
    lst2 = ajoute(lst2, 2)
    lst2 = ajoute(lst2, 6)
    lst = concatener(lst1, lst2)
    